import java.io.*;

public class Leitor implements Runnable {

	private boolean corre = false;

	private InputStreamReader isr = null;

	private SocketPOP3 receptor = null;

	private Thread leitor = null;

	public Leitor(SocketPOP3 receptor) {
		this.receptor = receptor;
	}

	public void parar() {
		corre = false;

		if (isr != null) {
			try {
				isr.close();
			} catch (IOException ioe) {
				System.err.println(ioe.getMessage());
			}
		}

		if (leitor != null) {
			try {
				leitor.join();
			} catch (InterruptedException ie) {
			}
		}
	}

	public void comear(InputStream is) {
		parar();
		this.isr = new InputStreamReader(is);
		corre = true;
		leitor = new Thread(this);
		leitor.start();
	}

	public void run() {
		int lidos = 0;

		while (corre) {
			try {
				receptor.novosDados(lerLinha(isr));
			} catch (IOException ioe) {
				System.err.println("run:" + ioe.getMessage());
			}
		}

	}

	/**
	 * L uma linha da resposta do servidor POP3. Todas as linhas
	 * terminam com \r\n.
	 */
	private String lerLinha(InputStreamReader isr) throws IOException {
		int c;
		StringBuffer sb = new StringBuffer();

		do {
			c = isr.read();
			if ((char)c == '\r') {
				c = isr.read();   // ler \n
			}
			if (c != -1 &&  (char)c != '\n') {
				sb.append((char)c);
			}
		} while (c != -1 &&  (char)c != '\n');
		if (sb.length() > 0 ) {
			return sb.append("\n").toString();
		} else {
			return null;
		}
	}
}