import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import java.io.*;
import javax.microedition.io.*;
import java.util.*;

public class SocketPOP3 extends MIDlet implements Runnable, CommandListener {

    /* Os dados para ligao ao servidor POP3.	*/
    private Form formLigao;
    private TextField servidorText;
    private TextField utilizadorText;
    private TextField passwordText;

	/* O ecr de comandos a enviar				*/
	private Form formComando;
	private TextField comandoText;

	/* O resultado da execuo de um comando	*/
    private TextField resultado;

	/* Os comandos da aplicao					*/
	private Command cmdSair, cmdLigar, cmdBuscar, cmdComando;

	/* A thread que envia os comandos para o servidor	*/
	private Thread executor = null;

	/* Flag para interromper a thread 					*/
	private boolean pararThread = false;

	/* A lista de comandos a enviar, funciona como uma pilha	*/
	private Vector comandos = new Vector();

    public SocketPOP3() {
     	cmdSair = new Command("Sair", Command.EXIT, 1);
      	cmdBuscar = new Command("Executar", Command.SCREEN, 1);
		cmdLigar = new Command("Ligar", Command.SCREEN, 1);
		cmdComando = new Command("Comando", Command.SCREEN, 1);

      	formLigao = new Form("Dados da ligao");
      	servidorText = new TextField("Servidor", "pop.jorgecardoso.org", 256, TextField.ANY);
      	utilizadorText = new TextField("Username", "jorgecardoso@jorgecardoso.org", 256, TextField.ANY);
      	passwordText = new TextField("Password", "", 32, TextField.PASSWORD);
      	formLigao.append(servidorText);
      	formLigao.append(utilizadorText);
      	formLigao.append(passwordText);
      	formLigao.addCommand(cmdSair);
      	formLigao.addCommand(cmdLigar);
      	formLigao.setCommandListener(this);

      	formComando = new Form("Comando a enviar");
      	comandoText = new TextField("Comando", "", 256, TextField.ANY);
      	resultado = new TextField("Resultado", "", 256, TextField.ANY);
      	formComando.append(comandoText);
      	formComando.append(resultado);
      	formComando.addCommand(cmdSair);
      	formComando.addCommand(cmdBuscar);
      	formComando.setCommandListener(this);

    }

    public void startApp() {
      	Display.getDisplay(this).setCurrent(formLigao);
    }

	public void destroyApp(boolean unconditional) {
		pararThread();
	}

	public void pauseApp() {
	}

	public void commandAction(Command c, Displayable d) {
		if (c == cmdSair) {
			destroyApp(true);
			notifyDestroyed();
		} else if (c == cmdLigar) {
			Display.getDisplay(this).setCurrent(formComando);
			executor = new Thread(this);
			executor.start();
			adicionaComando("user " + utilizadorText.getString());
			adicionaComando("pass " + passwordText.getString());
			adicionaComando("list");

		} else if (c == cmdComando) {
			Display.getDisplay(this).setCurrent(formComando);
		} else if (c == cmdBuscar) {
			adicionaComando(comandoText.getString());
		}
	}


	/**/private void adicionaComando(String comando) {
		synchronized(comandos) {
			comandos.addElement(comando);
			comandos.notify();
		}
	}/**/


	/**/private void pararThread() {
		pararThread = true;
		synchronized(comandos) {
			comandos.notify();
		}
		if (executor != null) {
			try {
				executor.join();
			} catch (InterruptedException ie) {
				System.err.println("Excepo:" + ie.getMessage());
			}
		}
	}/**/

	public void run() {

		InputStream is = null;
		OutputStream os = null;
		String comando = null;
		SocketConnection sc = null;
		/* criar a ligao socket ao servidor	*/
		try {
			 /**/sc = (SocketConnection)Connector.open("socket://"+servidorText.getString()+":110");/**/

			 is = sc.openInputStream();
   			 os = sc.openOutputStream();
		} catch (IOException ioe) {
			Alert a = new Alert("Erro", ioe.getMessage(), null, null);
			a.setTimeout(Alert.FOREVER);
			Display.getDisplay(this).setCurrent(a, formLigao);
			return;
		}

		Leitor l = new Leitor(this);
		l.comear(is);

		/**/while (!pararThread) {
			comando = null;
			synchronized(comandos) {
				if (comandos.size() > 0) {
					comando = (String)comandos.elementAt(0);
					comandos.removeElementAt(0);
				} else {
					try {
						comandos.wait();
					} catch (InterruptedException ie) {

					}
				}
			}
			if (comando != null) {
				try {
					System.out.println("Comando: " + comando);
					os.write(comando.getBytes());
					os.write("\r\n".getBytes());

				} catch (IOException ioe) {
					System.err.println("Excepo de IO: " + ioe.getMessage());
				}
			}

		}/**/
		try {
			if (is != null) {
				is.close();
			}
			if (os != null) {
				os.close();
			}
			if (sc != null) {
				sc.close();
			}
		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}
		l.parar();
	}

	public void novosDados(String linha) {
		if (linha == null) {
			return;
		}
		resultado.setMaxSize(resultado.getString().length()+linha.length());
		resultado.setString(resultado.getString()+linha);
	}


}